#!C:/Programs/Strawberry/win64/perl/bin/perl.exe -I"."

#####################################
#           Maths trainer           #
#####################################
# Quadratic equations in 1 variable #
#####################################

use strict; use warnings;

use CGI;
use CGI::Carp "fatalsToBrowser";

my $cgi = new CGI;
print "Content-Type: text/html\n\n";
print '<!DOCTYPE html>', "\n\n";
# -------------------------------------------------------------
# Set $app_dir to the full path of the directory,
# where the template file "equations1.template.html" is located
my $app_dir = "C:\\Programs\\Apache24\\htdocs";
# -------------------------------------------------------------
my $questions; my $question; my $usecomplex;
my $equation = ''; my $solution = '';
my $root1 = ''; my $root2 = '';
my $usolution; my $uroot; my $uroot1; my $uroot2; my $ucplxroot1; my $ucplxroot2;
my $evaluation; my $correct; my $correctanswer;
# Get parameters from 'calling' webpage and determine next button-push action
my %params = $cgi->Vars;
my $action = lc($params{'action'});
$action = 'init' unless ($action);
if ($action eq 'init' or $action eq 'new' or $action eq 'start' or $action eq 'next' or $action eq 'check') {
  my $nextaction;
  if ($action eq 'init' or $action eq 'new') {
    if ($action eq 'init') {
      $questions = 10;
      $usecomplex = '';
    }
    else {
      $questions = $params{'questions'};
      $usecomplex = $params{'usecomplex'};
    }
    $question = 0;
    $nextaction = 'start';
  }
  else {
    $question = $params{'hquestion'};
    if ($action eq 'start' or $action eq 'next') {
      if ($action eq 'start') {
        $questions = $params{'questions'};
        $usecomplex = $params{'usecomplex'};
        $correct = 0;
      }
      else {
        $questions = $params{'hquestions'};
        $usecomplex = $params{'husecomplex'};
        $correct = $params{'hcorrect'};
      }
      $nextaction = 'check';
    }
    elsif ($action eq 'check') {
      $questions = $params{'hquestions'};
      $usecomplex = $params{'husecomplex'};
      $correct = $params{'hcorrect'};
      if ($question < $questions) {
        $nextaction = 'next';
      }
      else {
        $nextaction = 'new';
      }
    }
  }
  $questions =~ s/[^0-9]*//g; $correct =~ s/[^0-9]*//g; $question =~ s/[^0-9]*//g;
  unless ($usecomplex eq 'usecomplex') {
    $usecomplex = '';
  }
  unless ($questions) {
    $questions = 10;
  }
  # Generate equation or check user answer
  if ($action eq 'start' or $action eq 'next') {
    $question++;
    # Generate equation
    ($equation, $solution, $root1, $root2) = generateEquation();
    $usolution = ''; $evaluation = '';
    $uroot1 = ''; $uroot2 = ''; $ucplxroot1 = ''; $ucplxroot2 = '';
  }
  elsif ($action eq 'check') {
    # Check user answer
    my $fcplx = '^(\d+|\d+\.\d+|-\d+|-\d+\.\d+|';
    $fcplx .= '\d*i|\d+\.\+*i|-\d*i|-\d+\.\d+i|';
    $fcplx .= '\d+ \+ \d*i|\d+ \+ \d+\.\d+i|\d+ - \d*i|\d+ - \d+\.\d+i|';
    $fcplx .= '-\d+ \+ \d*i|-\d+ \+ \d+\.\d+i|-\d+ - \d*i|-\d+ - \d+\.\d+i|';
    $fcplx .= '\d+\.\d+ \+ \d*i|\d+\.\d+ \+ \d+\.\d+i|\d+\.\d+ - \d*i|\d+\.\d+ - \d+\.\d+i|';
    $fcplx .= '-\d+\.\d+ \+ \d*i|-\d+\.\d+ \+ \d+\.\d+i|-\d+\.\d+ - \d*i|-\d+\.\d+ - \d+\.\d+i)$';
    $equation = $params{'hequation'};
    $equation =~ s/[^x²0-9\.\+\-\=\(\) ]*//g;
    $solution = $params{'hsolution'};
    unless ($solution eq 'none' or $solution eq 'onereal' or $solution eq 'tworeal' or $solution eq 'complex') {
      $solution = '';
    }
    $root1 = $params{'hroot1'}; $root2 = $params{'hroot2'};
    $root1 =~ s/\,/\./g;                                                       # this allows using the comma as decimal separator
    $root2 =~ s/\,/\./g;
    unless ($root1 =~ /$fcplx/) {                                              # check if roots calculated are complex or decimal numbers
      $root1 = '';
    }
    unless ($root2 =~ /$fcplx/) {
      $root2 = '';
    }
    $usolution = $params{'solution'};
    unless ($usolution eq 'onereal' or $usolution eq 'tworeal' or $usolution eq 'none' or $usolution eq 'complex') {
      $usolution = '';
    }
    $uroot = $params{'root'};
    $uroot1 = $params{'root1'}; $uroot2 = $params{'root2'};
    $ucplxroot1 = $params{'cplxroot1'}; $ucplxroot2 = $params{'cplxroot2'};
    $uroot =~ s/\,/\./g; $uroot1 =~ s/\,/\./g; $uroot2 =~ s/\,/\./g;           # this allows using the comma as decimal separator
    $ucplxroot1 =~ s/\,/\./g; $ucplxroot2 =~ s/\,/\./g;
    $ucplxroot1 =~ s/\s*\+\s*/ + /g; $ucplxroot1 =~ s/\s*-\s*/ - /g;           # adapt user input of complex numbers (real/img operator with spaces)
    $ucplxroot2 =~ s/\s*\+\s*/ + /g; $ucplxroot2 =~ s/\s*-\s*/ - /g;
    $ucplxroot1 =~ s/^\s-\s/-/g; $ucplxroot2 =~ s/^\s-\s/-/g;
    unless ($uroot =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                     # check if unique root entered is decimal number
      $uroot = '';
    }
    unless ($uroot1 =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {                    # check if real roots entered are decimal numbers
      $uroot1 = '';
    }
    unless ($uroot2 =~ /^(\d+|\d+\.\d+|-\d+|-\d+\.\d+)$/) {
      $uroot2 = '';
    }
    unless ($ucplxroot1 =~ /$fcplx/) {                                         # check if complex roots entered are complex numbers
      $ucplxroot1 = '';
    }
    unless ($ucplxroot2 =~ /$fcplx/) {
      $ucplxroot2 = '';
    }
    $correctanswer = 0;
    if ($usolution and $usolution eq $solution) {
      # Solution type (none, one real, two real, complex) = correct
      $correctanswer = 1;
      # Check if roots are correct
      if ($usolution eq 'onereal') {
        # One real root
        if ($uroot ne $root1) {
          $correctanswer = 0;
        }
      }
      elsif ($usolution eq 'tworeal') {
        # Two real roots
        if (!($uroot1 eq $root1 and $uroot2 eq $root2) and !($uroot1 eq $root2 and $uroot2 eq $root1)) {
          $correctanswer = 0;
        }
      }
      elsif ($usolution eq 'complex') {
        # Two complex roots
        if (!($ucplxroot1 eq $root1 and $ucplxroot2 eq $root2) and !($ucplxroot1 eq $root2 and $ucplxroot2 eq $root1)) {
          $correctanswer = 0;
        }
      }
    }
    # User answer evaluation
    if ($correctanswer) {
      # Correct answer
      $evaluation = 'This is correct!';
      $correct++;
    }
    else {
      # False answer (display correct answer)
      $evaluation = 'False! Correct is ';
      if ($solution eq 'onereal') {
        $evaluation .= 'one real solution x = ' . $root1 . '.';
      }
      elsif ($solution eq 'tworeal') {
        $evaluation .= ' two real solutions x = ' . $root1 . ', or x = ' . $root2 . '.';
      }
      elsif ($solution eq 'complex') {
        $evaluation .= ' two complex solutions x = ' . $root1 . ', or x = ' . $root2 . '.';
      }
      else {
        $evaluation .= 'no solution.';
      }
    }
  }
  # Read template HTML file
  my $template = "$app_dir\\eququad.template.html";
  open(my $input, "<", $template)
    or die "Can't open template file $template: $!";
  my @lines = <$input>;
  close($input);
  # Create the webpage
  foreach my $line (@lines) {
    chomp($line);
    if ($line) {
      if (substr($line, 0, 1) eq '#') {                                        # a '#' at beginning of line indicates that line contains a tag
        $line = substr($line, 1);
        if ($line =~ /#questions#/) {
          $line =~ s/#questions#/$questions/;                                  # number of questions
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#readonly#//;
          }
          else {
            $line =~ s/#readonly#/readonly="readonly"/;                        # disable modification of test-questions number during test
          }
        }
        elsif ($line =~ /#equationcount#/) {
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#equationcount#/Equation/;
          }
          else {
          $line =~ s/#equationcount#/Equation $question\/$questions/;          #  display actual question number
          }
          $line =~ s/#equation#/$equation/;
        }
        elsif ($line =~ /#checked_usecomplex#/) {
          if ($usecomplex eq 'usecomplex') {
            $line =~ s/#checked_usecomplex#/checked="checked"/;                # "Consider complex numbers" checkbox selected
          }
          else {
          $line =~ s/#checked_usecomplex#//;                                   # "Consider complex numbers" checkbox unselected
          }
        }
        elsif ($line =~ /#checked1#/) {
          if ($usolution eq 'onereal') {
            $line =~ s/#checked1#/checked="checked"/;                          # check 'One real solution' radiobutton
          }
          else {
            $line =~ s/#checked1#//;
          }
          $line =~ s/#root#/$uroot/;                                           # display unique real root (or nothing)
        }
        elsif ($line =~ /#checked2#/) {
          if ($usolution eq 'tworeal') {
            $line =~ s/#checked2#/checked="checked"/;                          # check 'Two real solutions' radiobutton
          }
          else {
            $line =~ s/#checked2#//;
          }
          $line =~ s/#root1#/$uroot1/;                                         # display first real root (or nothing)
          $line =~ s/#root2#/$uroot2/;                                         # display second real root (or nothing)
        }
        elsif ($line =~ /#checkedno#/) {
          if ($usecomplex) {
            $line = '';                                                        # do not display the 'No solution' line if complex numbers are considered
          }
          else {
            if ($usolution eq 'none') {
              $line =~ s/#checkedno#/checked="checked"/;                       # check 'No solution' radiobutton
            }
            else {
              $line =~ s/#checkedno#//;
            }
          }
        }
        elsif ($line =~ /#checkedcplx#/) {
          if ($usecomplex) {
            if ($usolution eq 'complex') {
              $line =~ s/#checkedcplx#/checked="checked"/;                     # check 'Complex solutions' radiobutton
            }
            else {
              $line =~ s/#checkedcplx#//;
            }
            $line =~ s/#cplxroot1#/$ucplxroot1/;                               # display first complex root (or nothing)
            $line =~ s/#cplxroot2#/$ucplxroot2/;                               # display second complex root (or nothing)
          }
          else {
            $line = '';                                                        # do not display the 'Complex roots' line if complex numbers aren't considered
          }
        }
        elsif ($line =~ /#eval#/) {
          if ($evaluation) {
            $line =~ s/#eval#/$evaluation/;
            if ($correctanswer) {
              $line =~ s/#class#/class="bold"/;                                # display evaluation in black bold, if correct answer
            }
            else {
              $line =~ s/#class#/class="red"/;                                 # display evaluation in red bold, if false answer
            }
          }
          else {
            $line =~ s/#eval#/&nbsp;/;                                         # no evaluation displayed (case if question is asked)
            $line =~ s/ #class#//;
          }
        }
        elsif ($line =~ /#button#/) {
          my $button = ucfirst($nextaction);
          $line =~ s/#button#/$button/;                                        # set button caption for next button push action
        }
        elsif ($line =~ /#table#/) {
          # Display test evaluation table (at end of test)
          if ($nextaction eq 'new' and $questions >= 5) {                      # evaluate only, if there were at least 5 questions
            my $false = $questions - $correct;
            my $success = 100 * ($correct / $questions); $success = int($success + 0.5);
            # Use spaces (&nbsp;) to right-align the count values
            my $tquestions = sprintf("%4u", $questions); $tquestions =~ s/ /&nbsp; /g;
            my $tcorrect = sprintf("%4u", $correct); $tcorrect =~ s/ /&nbsp; /g;
            $false = sprintf("%4u", $false); $false =~ s/ /&nbsp; /g;
            $success = sprintf("%3u", $success); $success =~ s/ /&nbsp; /g;
            # Create table HTML
            my $table = '<table border="1" style="padding:5px">';
            $table .= '<tr><th colspan="2" align="center" style="padding:5px">Evaluation</td></tr>';
            $table .= '<tr><td style="padding:5px">Questions</td><td style="padding:5px">' . $tquestions . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Correct</td><td style="padding:5px">' . $tcorrect . '</td></tr>';
            $table .= '<tr><td style="padding:5px">False</td><td style="padding:5px">' . $false . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Success</td><td style="padding:5px">' . $success . '%</td></tr>';
            $table .= '</table>';
            $line =~ s/#table#/$table/;
          }
          # Displaay nothing if test not yet done
          else {
            $line =~ s/#table#/&nbsp;/;
          }
        }
        elsif ($line =~ /#hquestions#/) {
          $line =~ s/#hquestions#/$questions/;                                 # save test-questions number to hidden field
        }
        elsif ($line =~ /#husecomplex#/) {
          $line =~ s/#husecomplex#/$usecomplex/;                               # save complex number usage to hidden field
        }
        elsif ($line =~ /#hquestion#/) {
          $line =~ s/#hquestion#/$question/;                                   # save actual question number to hidden field
        }
        elsif ($line =~ /#hequation#/) {
          $line =~ s/#hequation#/$equation/;                                   # save equation string to hidden field
        }
        elsif ($line =~ /#hsolution#/) {
          $line =~ s/#hsolution#/$solution/;                                   # save actual solution (none, one real, two real, coplex) to hidden field
        }
        elsif ($line =~ /#hroot1/) {
          $line =~ s/#hroot1#/$root1/;                                         # save actual first to hidden field
        }
        elsif ($line =~ /#hroot2#/) {
          $line =~ s/#hroot2#/$root2/;                                         # save actual second root to hidden field
        }
        elsif ($line =~ /#hcorrect#/) {
          $line =~ s/#hcorrect#/$correct/;                                     # save number of correct answers to hidden field
        }
      }
    }
    # Print file-line (with tags replaced) to webpage
    unless ($line =~ /#/) {
      print "$line\n";
    }
  }
}

# -----------------------------------------
# Generate quadratic equation in 1 variable
# -----------------------------------------

sub generateEquation {
  my ($equation, $solution, $root1, $root2);
  my $a; my $b; my $c; my $delta;
  my $ok; my $t;
  # $t is used to control the % of real/complex resp. real/none solutions
  if ($usecomplex eq 'usecomplex') {
    $t = int(rand(2));
  }
  else {
    $t = int(rand(10));
  }
  do {
    $ok = 1;

    do {
      $ok = 1;
      do {
        # Coefficient a from -25 to 25, but not zero
        $a = int(rand(51)) - 25;
      } until ($a);
      do {
        # Coefficient b from -10 to 10, but not zero
        $b = int(rand(21)) - 10;
      } until ($b);
      # Coefficient c from -25 to 25
      $c = int(rand(51)) - 25;
      if ($c == 0 and int(rand(10)) != 0) {                                    # limit equations with c = 0
        $c = int(rand(51)) - 25;
      }
      # Calculate Delta
      $delta = $b * $b - 4 * $a * $c;
      if ($usecomplex eq 'usecomplex') {
        if (($t == 0 and $delta < 0) or ($t == 1 and $delta >= 0)) {           # 50% real, 50% complex roots
          $ok = 0;
        }
      }
      else {
        if ($t != 0 and $delta < 0) {                                          # 10% no solutions
          $ok = 0;
        }
      }
    } until ($ok);
    if ($delta >= 0) {
      if ($delta > 0) {
        $solution = 'tworeal';                                                 # Delta > 0: two real solutions
      }
      else {
        $solution = 'onereal';                                                 # Delta = 0: one real solutions
      }
    }
    else {
      if ($usecomplex eq 'usecomplex') {
        $solution = 'complex';                                                 # Delta < 0: two complex solutions (if complex numbers are considered)
      }
      else {
        $solution = 'none';                                                    # Delta < 0: no solution (if complex numbers aren't considered)
      }
    }
    # Determine equation solution(s)
    # Reject this equation (and generate a new one) if the roots (resp. the
    # real or imaginery part of the root) have more than 3 decimal digits
    if ($solution eq 'onereal' or $solution eq 'tworeal') {
      # Delta >= 0: One double or two real solutions
      $root1 = (-$b + sqrt($delta)) / (2 * $a);
      $root2 = (-$b - sqrt($delta)) / (2 * $a);
      if ((1000 * $root1 != int(1000 * $root1)) or (1000 * $root2 != int(1000 * $root2))) {
        # Roots with a maximum of 3 decimal digits
        $ok = 0;
      }
    }
    elsif ($solution eq 'complex') {
      # Delta < 0: Two complex solutions
      my $r = -$b / (2 * $a); my $i = sqrt(-$delta) / (2 * $a);
      if ((1000 * $r != int(1000 * $r)) or (1000 * $i != int(1000 * $i))) {
        # Real and imaginary parts of roots with a maximum of 3 decimal digits
        $ok = 0;
      }
      else {
        # Construct the complex root
        if ($r == 0) {
          # If real part is zero, use imaginery part only
          $root1 = $i . 'i';
          $root2 = -$i . 'i';
        }
        else {
          # Normal case (real and imaginary part)
          $root1 = $r . ' + '; $root2 = $r . ' - ';
          if (abs($i) == 1) {
            # Use i and -i instead  of 1i and -1i
            $root1 .= 'i';
            $root2 .= 'i';
          }
          else {
            $root1 .= abs($i) . 'i';
            $root2 .= abs($i) . 'i';
          }
        }
      }
    }
  } until $ok;
  # Create equation string
  $equation = formatEquation($a, $b, $c);
  return($equation, $solution, $root1, $root2);
}

# ---------------------------------------
# Format equation string (pretty display)
# ---------------------------------------

sub formatEquation {

  my ($a, $b, $c) = @_;
  my $equation = '';
  if (abs($a) != 1) {
    $equation = $a;                                                            # print a only if not 1 or -1
  }
  elsif ($a == -1) {
    $equation = '-';                                                           # print -x² instead of -1x²
  }
  $equation .= 'x²';
  if ($b > 0) {
    $equation .= ' + ';                                                        # plus sign if b > 0
  }
  else {
    $equation .= ' - ';                                                        # minus sign if b < 0
  }
  unless (abs($b) == 1) {
    $equation .= abs($b);                                                      # print b only if not 1 or -1
  }
  $equation .= 'x';
  unless ($c == 0) {                                                           # print c only if not 0
    if ($c > 0) {
      $equation .= ' + ';
    }
    else {
      $equation .= ' - ';
    }
    $equation .= abs($c);
  }
  $equation .= ' = 0';
  return($equation);

}
